package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRPost;
import cn.ibizlab.humanresource.core.humanresource.filter.HRPostSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRPost] 服务对象接口
 */
public interface IHRPostService extends IService<HRPost>{

    boolean create(HRPost et) ;
    void createBatch(List<HRPost> list) ;
    boolean update(HRPost et) ;
    void updateBatch(List<HRPost> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRPost get(String key) ;
    HRPost getDraft(HRPost et) ;
    boolean checkKey(HRPost et) ;
    boolean save(HRPost et) ;
    void saveBatch(List<HRPost> list) ;
    Page<HRPost> searchDefault(HRPostSearchContext context) ;
    List<HRPost> selectByHrdutyid(String hrdutyid) ;
    void removeByHrdutyid(String hrdutyid) ;
    List<HRPost> selectByHrorganizationid(String organizationid) ;
    void removeByHrorganizationid(String organizationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRPost> getHrpostByIds(List<String> ids) ;
    List<HRPost> getHrpostByEntities(List<HRPost> entities) ;
}


